package concur;

import java.util.ArrayList;
import java.util.List;
import java.util.Random;
import java.util.concurrent.ArrayBlockingQueue;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;
import java.util.concurrent.RecursiveTask;

class Somme extends RecursiveTask<Long> {
	private int debut;
	private int fin;
	public Somme(int d,int f) {
		debut = d;
		fin = f;
	}
	@Override
	protected Long compute() {
		if (fin-debut<100_000) {
			System.out.println(Thread.currentThread().getId()+" "+debut+"------"+fin);
			long r = 0;
			for (int i=debut; i<fin; i++) r += i;
			return r;
		}
		int milieu = (fin-debut)/2+debut;
		Somme gauche = new Somme(debut,milieu);
		Somme droite = new Somme(milieu,fin);
		droite.fork();
		return gauche.compute()+droite.join();
	}
}

public class Main {
	private static Random r = new Random();

	public static void main(String[] args) throws InterruptedException, ExecutionException {
		ExecutorService es = Executors.newFixedThreadPool(5);
		
		ArrayBlockingQueue<Integer> q = new ArrayBlockingQueue<>(5);
		for (int i=0; i<10; i++) {
			int v = i;
			es.submit( ()-> {
					try {
						Thread.sleep(r.nextInt(2000)+500);
						System.out.println(v+" a terminé");
						q.put(v);
					} catch (InterruptedException e) {
					}
				});
			}
	
		System.out.println("main...");
		
		for (int i=0; i<10; i++) {
			int r = q.take();
			System.out.println("Resultat "+r);
		}
		
		es.shutdown();
		
		Somme s = new Somme(0,1_000_000_000);
		System.out.println(s.compute());
		
		List<Integer> li = new ArrayList<>();
		for (int i=0; i<100; i++) li.add(i);
		
		li.stream()
			.parallel()
			.peek(i->System.out.println(Thread.currentThread().getId()+" Je vois passer "+i))
			.forEach(i->{});
	}

}
